﻿//
import SD.RD;
import SGF.GamePiece;

//Can extend GamePiece or GameCollisionPiece
class IDTheftGame.GenFacialsMC extends GamePiece{
	
	
	//************************************************************
	//PRIVATE VARS
	//************************************************************
	
	//Private vars
	private var keepPlayingMessage:String;
	private var btnsPermatentlyDisabled:Array;
	
	//Public vars
	
	
	//Sub MC Vars
	private var f1:MovieClip;
	private var f2:MovieClip;
	private var f3:MovieClip;
	private var f4:MovieClip;
	private var f5:MovieClip;
	private var f6:MovieClip;
	
	private var fb1:MovieClip;
	private var fb2:MovieClip;
	private var fb3:MovieClip;
	private var fb4:MovieClip;
	private var fb5:MovieClip;
	private var fb6:MovieClip;
	
	
	private var btn1:Button;
	private var btn2:Button;
	private var btn3:Button;
	private var btn4:Button;
	private var btn5:Button;
	private var btn6:Button;
	
	//private var selectBtnWhite:Button;
	//private var selectBtnBlue:Button;
	
	
	
	//Sub TextField vars
	
	
	//Property vars
	
	
	
	//************************************************************
	//PROPERTIES
	//************************************************************
	
	
	

	//************************************************************
	//CONSTRUCTOR FUNCTIONS
	//************************************************************

	public function GenFacialsMC(){
		
		//trace("GameController Created");
		//RD.D("GameController Created", this);
		linkageName = "GenFacialsMC";
		makeThisADispatcher();
		//dispatchMyEvent("e_someEvent", {myMessage:"none"});
		initiate();
		
	}
	
	
	
	//************************************************************
	//INITIAL FUNCTIONS: Usually functions off the constructor
	//************************************************************
	public function initiate(){
		
		_visible = false;
		v_disableBtns();
		
		btnsPermatentlyDisabled = new Array();
		
		btn1._alpha = 100;
		btn2._alpha = 100;
		btn3._alpha = 100;
		btn4._alpha = 100;
		btn5._alpha = 100;
		btn6._alpha = 100;
		
		f1._alpha = 100;
		f2._alpha = 100;
		f3._alpha = 100;
		f4._alpha = 100;
		f5._alpha = 100;
		f6._alpha = 100;
		
		fb1._alpha = 100;
		fb2._alpha = 100;
		fb3._alpha = 100;
		fb4._alpha = 100;
		fb5._alpha = 100;
		fb6._alpha = 100;
		
	}
	
	
	//************************************************************
	//PUBLIC VISUAL FUNCTIONS: Functions that hide and show items in the MC
	//************************************************************
	
	//************************************************************
	//PRIVATE VISUAL FUNCTIONS: Functions that hide and show items in the MC
	//************************************************************
	private function v_disableBtns(){
		
		for(var x = 1; x < 7; x++){
	
				eval(this + ".btn" + x).enabled = false;
	
		}
		
		
	}
	
	
	private function v_enableBtns(){
		
		var thisBtn:Button;
		var doEnable:Boolean;
		for(var x = 1; x < 7; x++){
			doEnable = true;
			thisBtn = eval(this + ".btn" + x);
			
			for(var z = 0; z < btnsPermatentlyDisabled.length; z++){
				
				if(btnsPermatentlyDisabled[z] == thisBtn){doEnable = false;}
				
			}
			
			if(doEnable){thisBtn.enabled = true;}
			
		}
			
	}
	
	
	//************************************************************
	//PUBLIC VISUAL STRUCTURAL FUNCTIONS: Functions that affect the visuals and structure of the MC 
	//************************************************************


	//************************************************************
	//PRIVATE VISUAL STRUCTURAL FUNCTIONS: Functions that affect the visuals and structure of the MC 
	//************************************************************
	private function selectFacials(myMessage:String){
		
		enabled = true;
		v_enableBtns();
		
		keepPlayingMessage = myMessage;
	
	}
	
	
	
	private function addFacialToFace(facialNum:Number){
		
		v_disableBtns();
		
		var thisBtn:Button = eval(this + ".btn" + facialNum);
		var thisFeature:MovieClip = eval(this + ".f" + facialNum);
		var thisFeatureBG:MovieClip = eval(this + ".fb" + facialNum);
		btnsPermatentlyDisabled.push(thisBtn);
		thisFeature.tween("_alpha", 20, 1, "CustomEasing",0);
		thisFeatureBG.tween("_alpha", 20, 1, "CustomEasing",0);
		
		
		if(keepPlayingMessage == "keepPlaying"){
		
			//send event to Character MC to add facial
			dispatchMyEvent("e_addFeature", {myMessage:String(facialNum)});
			
			//send event to continue with questions or results
			dispatchMyEvent("e_featurePlaced", {myMessage:keepPlayingMessage});
			
		}else{
			
			//show results
			dispatchMyEvent("e_gameFinished", {myMessage:"none"});
		
			//send event to Character MC to add facial
			dispatchMyEvent("e_addFeature", {myMessage:String(facialNum)});
		
		
		}
		
	}
	
	//************************************************************
	//PUBLIC CHARACTER FUNCTIONS: Functions that animate characters
	//************************************************************
	
	
	//************************************************************
	//PRIVATE CHARACTER FUNCTIONS: Functions that animate characters
	//************************************************************
	
	
	
	//************************************************************
	//PUBLIC GENERAL FUNCTIONS
	//************************************************************
	
	
	//************************************************************
	//PRIVATE GENERAL FUNCTIONS
	//************************************************************
	
	
	//************************************************************
	//PRIVATE HELPER FUNCTIONS
	//************************************************************

	
	//************************************************************
	//REGULAR EVENT FUNCTIONS: Functions that fire off regular MC events
	//************************************************************
	private function e_addFacialToFace(facialNum:Number){
		
		addFacialToFace(facialNum);
		
	}
	
	//************************************************************
	//CUSTOM LOCAL EVENT FUNCTIONS: Functions that fire off events written into a MC
	//************************************************************
	
	
	//************************************************************
	//CUSTOM EVENT FUNCTIONS: Functions that fire off custom made events
	//************************************************************
	//
	public function e_userCorrect(evt:Object):Void {
		
			RD.D("e_userCorrect = " + evt.messageObject.myMessage, this);
			selectFacials(evt.messageObject.myMessage);
		
	}
	
	//************************************************************
	//CHARACTER EVENT FUNCTIONS: Events fired from character movements
	//************************************************************
	

	
	
	
	
	
	
	
	
}