//
import SD.RD;
import SGF.GamePiece;

//Can extend GamePiece or GameCollisionPiece
class IDTheftGame.QuestionsMCC extends GamePiece{
	
	
	//************************************************************
	//PRIVATE VARS
	//************************************************************
	
	//Private vars
	private var qAArrayCount:Number;
	
	//Public vars
	
	
	//Sub MC Vars
	private var QuestionsMC:MovieClip;
	private var btnOverlayMCT:MovieClip;
	private var btnOverlayMCF:MovieClip;
	private var b_true:Button;
	private var b_false:Button;
	
	
	//Sub TextField vars
		
	
	//Property vars
	
	
	
	//************************************************************
	//PROPERTIES
	//************************************************************
	
	
	

	//************************************************************
	//CONSTRUCTOR FUNCTIONS
	//************************************************************

	public function QuestionsMCC(){
		
		//trace("GameController Created");
		//RD.D("GameController Created", this);
		linkageName = "QuestionsMCC";
		_visible = false;
		enabled = false;
		makeThisADispatcher();
		//dispatchMyEvent("e_someEvent", {myMessage:"none"});
		
	}
	
	
	
	//************************************************************
	//INITIAL FUNCTIONS: Usually functions off the constructor
	//************************************************************
	public function initiateQuestions(){
		
		QuestionsMC.RandomizeQuestions();
		qAArrayCount = 0;
		
	}
	
	
	//************************************************************
	//PUBLIC VISUAL FUNCTIONS: Functions that hide and show items in the MC
	//************************************************************
	
	//************************************************************
	//PRIVATE VISUAL FUNCTIONS: Functions that hide and show items in the MC
	//************************************************************
	private function v_disableQuestions(){
		
		b_true.enabled = false;
		b_false.enabled = false;
		
	}
	
	
	private function v_enableQuestions(){
		
		b_true.enabled = true;
		b_false.enabled = true;
		
	}
	
	
	//************************************************************
	//PUBLIC VISUAL STRUCTURAL FUNCTIONS: Functions that affect the visuals and structure of the MC 
	//************************************************************
	public function askQuestion(){
		
		v_enableQuestions();
		qAArrayCount = QuestionsMC.askQuestion();
		btnOverlayMCT.gotoAndStop("off");
		btnOverlayMCF.gotoAndStop("off");
		
	}

	//************************************************************
	//PRIVATE VISUAL STRUCTURAL FUNCTIONS: Functions that affect the visuals and structure of the MC 
	//************************************************************
	
	
	//************************************************************
	//PUBLIC CHARACTER FUNCTIONS: Functions that animate characters
	//************************************************************
	
	
	//************************************************************
	//PRIVATE CHARACTER FUNCTIONS: Functions that animate characters
	//************************************************************
	
	
	
	//************************************************************
	//PUBLIC GENERAL FUNCTIONS
	//************************************************************
	
	
	//************************************************************
	//PRIVATE GENERAL FUNCTIONS
	//************************************************************
	private function userAnsweredQuestion(answer:Boolean, BtnOverMC:MovieClip){
		
		v_disableQuestions();
		var userResponse:Boolean = QuestionsMC.checkUserResponse(answer);

		getRef().score.updateScore(userResponse);
		
		if(getRef().score.Misses < 3){
			
			//keep playing1
			if(getRef().score.UserScore != 6 && qAArrayCount != 8){
			
				//keep playing2
				//send event that user can choose a facial feature but let it be known that the user keeps playing
				if(userResponse){
					
					//user was correct
					getRef().gameSounds.playSound("CorrectResponse");
					BtnOverMC.gotoAndStop("true");
					dispatchMyEvent("e_userCorrect", {myMessage:"keepPlaying"});
				
				}else{
					
					//user was incorrect
					getRef().gameSounds.playSound("IncorrectResponse");
					BtnOverMC.gotoAndStop("false");
					dispatchMyEvent("e_featurePlaced", {myMessage:"none"});
					dispatchMyEvent("e_userInCorrect", {myMessage:"none"});
				
				}
				
			}else{
				
				//out of questions or user has scored 6 correct questions or between 6-8 correct or incorrect
				//send event that user can choose a facial feature but let it be known that the user stops playing
				if(userResponse){
					
					//change the message to select a facial feature then hit results
					QuestionsMC.txtDirection.text = "Usted acert! Elija la ltima caracterstica a mano izquierda y haga clic en Resultados abajo.";
					getRef().gameSounds.playSound("CorrectResponse");
					BtnOverMC.gotoAndStop("true");
					dispatchMyEvent("e_userCorrect", {myMessage:"stopPlaying"});
					getRef().score.Win = true;
					
					
				}else{
					
					//user got the last question incorrect
					QuestionsMC.txtDirection.text = "Haga clic en Resultados para ver como le fue.";
					getRef().gameSounds.playSound("IncorrectResponse");
					BtnOverMC.gotoAndStop("false");
					//show results
					dispatchMyEvent("e_gameFinished", {myMessage:"none"});
					
					dispatchMyEvent("e_userInCorrect", {myMessage:"none"});
					
				}
			}
		
		}else{
			
			//too many misses, finish game
			QuestionsMC.txtDirection.text = "Haga clic en Resultados para ver como le fue.";
			getRef().gameSounds.playSound("IncorrectResponse");
			BtnOverMC.gotoAndStop("false");
			//show results
			dispatchMyEvent("e_gameFinished", {myMessage:"none"});
			
			dispatchMyEvent("e_userInCorrect", {myMessage:"none"});
			
		}
	}
	
	
	
	//************************************************************
	//PRIVATE HELPER FUNCTIONS
	//************************************************************

	
	//************************************************************
	//REGULAR EVENT FUNCTIONS: Functions that fire off regular MC events
	//************************************************************
	private function e_userAnsweredQuestion(answer:Boolean, BtnOverMC:MovieClip){
		
		userAnsweredQuestion(answer, BtnOverMC);
		
	}
	
	//************************************************************
	//CUSTOM LOCAL EVENT FUNCTIONS: Functions that fire off events written into a MC
	//************************************************************
	//
	public function e_nextQuestion(evt:Object):Void {
		
			askQuestion();
		
	}
	
	//************************************************************
	//CUSTOM EVENT FUNCTIONS: Functions that fire off custom made events
	//************************************************************
	
	
	//************************************************************
	//CHARACTER EVENT FUNCTIONS: Events fired from character movements
	//************************************************************
	

	
	
	
	
	
	
	
	
}